/// (C) Daniel Kirstenpfad
/// eMail: btk@schrankmonster.de
/// http://www.technology-ninja.com
/// 
/// smtp.cs (C) Randy Charles Morin: http://www.kbcafe.com/articles/HowTo.SMTP.CSharp.pdf
/// 
/// Use it at your own risk. This code is released under the BSD license.
/// 
using System;
using System.Collections.Generic;
using System.Text;
using Exchange2SMTP.EWSReference;
using System.Net;
using System.IO;
using System.Security.Cryptography.X509Certificates;
using System.Net.Security;
using System.Xml.Serialization;

namespace Exchange2SMTP
{
    class Exchange2SMTP
    {
        public static String ExchangeWebserviceURL = @"https://yourserver/EWS/Exchange.asmx";
        public static NetworkCredential Credentials = new NetworkCredential("username", "password", "domain");

        public static String SMTPServer = "yoursmtpserver";
        public static String TO_EMAIL = "to@domain.com";

        static void Main(string[] args)
        {

            #region Webservice
            ExchangeServiceBinding exchangeServer = new ExchangeServiceBinding();
            #endregion

            #region Webservice URL / User Data...
            exchangeServer.Url = ExchangeWebserviceURL;
            exchangeServer.Credentials = Credentials;
            #endregion

            #region Enumerate All Items in the Inbox
            // Form the FindItem request
            FindItemType findItemRequest = new FindItemType();
            GetItemType retrieveItems = new GetItemType();
            findItemRequest.Traversal = ItemQueryTraversalType.Shallow;

            // Define which item properties are returned in the response
            ItemResponseShapeType itemProperties = new ItemResponseShapeType();
            itemProperties.BaseShape = DefaultShapeNamesType.IdOnly;

            // Add properties shape to request
            findItemRequest.ItemShape = itemProperties;

            // Identify which folders to search to find items
            DistinguishedFolderIdType[] folderIDArray = new DistinguishedFolderIdType[1];
            folderIDArray[0] = new DistinguishedFolderIdType();
            folderIDArray[0].Id = DistinguishedFolderIdNameType.inbox;

            // Add folders to request
            findItemRequest.ParentFolderIds = folderIDArray;

            try
            {
                // Send the request and get the response
                FindItemResponseType findItemResponse = exchangeServer.FindItem(findItemRequest);

                // Get the response messages
                ResponseMessageType[] rmta = findItemResponse.ResponseMessages.Items;

                foreach (ResponseMessageType rmt in rmta)
                {
                    FindItemResponseMessageType firmt = (FindItemResponseMessageType)rmt;

                    ArrayOfRealItemsType founditems = (ArrayOfRealItemsType)firmt.RootFolder.Item;

                    retrieveItems.ItemIds = new BaseItemIdType[founditems.Items.Length];

                    for (int i = 0; i <= founditems.Items.Length - 1; i++)
                    {
                        retrieveItems.ItemIds[i] = founditems.Items[i].ItemId;
                    }
                }
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
            }
            #endregion

            #region Retrieve the previously enummerated Items...
            GetItemResponseType girt = null;
            try
            {
                #region Set some options
                retrieveItems.ItemShape = new ItemResponseShapeType();
                retrieveItems.ItemShape.BaseShape = DefaultShapeNamesType.AllProperties;
                retrieveItems.ItemShape.BodyType = BodyTypeResponseType.Best;
                retrieveItems.ItemShape.BodyTypeSpecified = true;
                retrieveItems.ItemShape.IncludeMimeContent = true;
                retrieveItems.ItemShape.IncludeMimeContentSpecified = true;
                #endregion

                girt = exchangeServer.GetItem(retrieveItems);
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
            }
            #endregion

            #region Construct the Messages and drop them
            if (girt != null)
            {
                foreach (ItemInfoResponseMessageType MessageItem in girt.ResponseMessages.Items)
                {
                    ItemType thisItem = (ItemType)MessageItem.Items.Items[0];
                    MessageType thisMessage = (MessageType)thisItem;
                    
                    // send as smtp message
                    try
                    {
                        Smtp smtp = new Smtp();
                        smtp.server = SMTPServer;
                        smtp.from = thisMessage.From.Item.EmailAddress+" ("+thisMessage.From.Item.Name+")";
                        smtp.subject = thisItem.Subject;
                        smtp.bodyHtml = thisItem.Body.Value;

                        InternetHeaderType[] MailHeaders = thisItem.InternetMessageHeaders;
                        foreach (InternetHeaderType HeaderLine in MailHeaders)
                        {
                            if (HeaderLine.HeaderName.ToUpper() != "SUBJECT")
                            {
                                if (HeaderLine.HeaderName.ToUpper() != "FROM")
                                {
                                    smtp.headers.Add(HeaderLine.HeaderName + ": " + HeaderLine.Value);
                                }
                            }
                        }

                        foreach (EmailAddressType toEmail in thisMessage.ToRecipients)
                        {
                            smtp.headers.Add("Original-To: " + toEmail.EmailAddress + " (" + toEmail.Name + ")");
                        }

                        smtp.to.Add(TO_EMAIL);
                        smtp.Send();
                        // only the first message
                        //break;

                    }
                    catch (SmtpException e)
                    {
                        System.Console.WriteLine("{0}", e.What());
                    }

                }
            }
            #endregion
        }
    }
}